using UnityEngine;
using NeonTea.Quakeball.Game;
using NeonTea.Quakeball.TeaNet.Packets;

namespace NeonTea.Quakeball.Networking.Packets {

    public class SelfIdentPckt : Packet {
        public ulong PlayerId;
        public Team Team;

        public SelfIdentPckt() { }
        public SelfIdentPckt(ulong id, Team team) {
            PlayerId = id;
            Team = team;
        }

        public override void Read(ByteBuffer buffer) {
            PlayerId = buffer.ReadULong();
            Team = (Team)buffer.Read();
        }

        public override void Write(ByteBuffer buffer) {
            buffer.Write(PlayerId);
            buffer.Write((byte)Team);
        }

    }

    public class NicknamePckt : Packet {
        public ulong PlayerId;
        public string Nick;

        public NicknamePckt() { }
        public NicknamePckt(string nick, ulong id = 0) {
            Nick = nick;
            PlayerId = id;
        }

        public override void Read(ByteBuffer buffer) {
            PlayerId = buffer.ReadULong();
            Nick = buffer.ReadString();
        }

        public override void Write(ByteBuffer buffer) {
            buffer.Write(PlayerId);
            buffer.Write(Nick);
        }
    }
}